unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, DB, IBCustomDataSet, IBQuery, IBDatabase,
  UnitV, Unit2, Unit3, Unit4, Unit5  ;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button0: TButton;
    IBDatabase1: TIBDatabase;
    IBTransaction1: TIBTransaction;
    IBQuery1: TIBQuery;
    ComboBox1: TComboBox;
    Button5: TButton;
    Button6: TButton;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button0Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
  private
    { Private 錾 }
    DatFile : string ;  // f[^t@C
    procedure OpenDatFile(fn:string) ;
    procedure SaveDatFile(fn:string) ;
  public
    { Public 錾 }
    procedure DataBaseConnect ;
    procedure DataBaseDisConnect ;
    function  DataTableCheck(t:string) : Boolean ;
    function  DataTableMaking1 : Boolean ;
    function  DataTableDelete1 : Boolean ;
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

// f[^t@Cǂݍ
procedure TForm1.OpenDatFile(fn:string) ;
var
   F : TextFile ;
   s : string ;
   i : integer ;
begin
   DBserv := '192.168.1.10:';
   DBfold := 'C:\data\';
   DBname := 'ADDRESS.FDB';
   Form5.Width := 320 ;
   Form5.Height:= 240 ;
   for i:=0 to Form5.StringGrid1.ColCount-1 do
      Form5.StringGrid1.ColWidths[i] := 80;

   // ǂݍ
   if not(FileExists(fn)) then exit;
   try
      AssignFile(F, fn);
      FileMode := 0;
      Reset(F);

      ReadLn(F, DBserv);
      ReadLn(F, DBfold);
      ReadLn(F, DBname);
      ReadLn(F, s);  Form1.Left  := SInt(s) ;
      ReadLn(F, s);  Form1.Top   := SInt(s) ;
      ReadLn(F, s);  Form2.Left  := SInt(s) ;
      ReadLn(F, s);  Form2.Top   := SInt(s) ;
      ReadLn(F, s);  Form3.Left  := SInt(s) ;
      ReadLn(F, s);  Form3.Top   := SInt(s) ;
      ReadLn(F, s);  Form4.Left  := SInt(s) ;
      ReadLn(F, s);  Form4.Top   := SInt(s) ;
      ReadLn(F, s);  Form5.Left  := SInt(s) ;
      ReadLn(F, s);  Form5.Top   := SInt(s) ;
      ReadLn(F, s);  Form5.Width := SInt(s) ;
      ReadLn(F, s);  Form5.Height:= SInt(s) ;
      for i:=0 to Form5.StringGrid1.ColCount-1 do begin
         ReadLn(F, s);
         Form5.StringGrid1.ColWidths[i] := SInt(s) ;
      end;

      CloseFile(F);
   except
      CloseFile(F);
   end;
end;

// f[^t@Cۑ
procedure TForm1.SaveDatFile(fn:string) ;
var
   F : TextFile ;
   s : string ;
   i : integer ;
begin
   try
      AssignFile(F, fn);
      ReWrite(F);

      WriteLn(F, DBserv);
      WriteLn(F, DBfold);
      WriteLn(F, DBname);
      s := IntToStr(Form1.Left);    WriteLn(F, s);
      s := IntToStr(Form1.Top);     WriteLn(F, s);
      s := IntToStr(Form2.Left);    WriteLn(F, s);
      s := IntToStr(Form2.Top);     WriteLn(F, s);
      s := IntToStr(Form3.Left);    WriteLn(F, s);
      s := IntToStr(Form3.Top);     WriteLn(F, s);
      s := IntToStr(Form4.Left);    WriteLn(F, s);
      s := IntToStr(Form4.Top);     WriteLn(F, s);
      s := IntToStr(Form5.Left);    WriteLn(F, s);
      s := IntToStr(Form5.Top);     WriteLn(F, s);
      s := IntToStr(Form5.Width);   WriteLn(F, s);
      s := IntToStr(Form5.Height);  WriteLn(F, s);
      for i:=0 to Form5.StringGrid1.ColCount-1 do begin
         s := IntToStr(Form5.StringGrid1.ColWidths[i]) ;
         WriteLn(F, s);
      end;

      CloseFile(F);
   except
      CloseFile(F);
      if FileExists(fn) then DeleteFile(fn);
   end;
end;

// f[^x[Xɐڑ
procedure TForm1.DataBaseConnect ;
begin
   // f[^x[Xڑ
   IBDataBase1.DatabaseName := DBserv + DBfold + DBname ;
   IBDataBase1.Connected := False ;
   IBDatabase1.Params.Clear ;
   IBDatabase1.Params.Add('USER_NAME=SYSDBA');
   IBDatabase1.Params.Add('PASSWORD=masterkey');
   try
      IBDatabase1.Connected := True ;
   except
      // G[f[^x[Xؒf
      DataBaseDisConnect ;
   end;
end;

// f[^x[Xؒf
procedure TForm1.DataBaseDisConnect ;
begin
   IBQuery1.Active := False ;
   IBTransaction1.Active := False ;
   IBDatabase1.Connected := False ;
end;

// f[^e[ũ`FbN
function TForm1.DataTableCheck(t:string) : Boolean ;
begin
   ComboBox1.Items.Clear ;
   IBDatabase1.GetTableNames(ComboBox1.Items);
   if ComboBox1.Items.IndexOf(t) >= 0 then
      Result := True
   else
      Result := False ;
end;

// f[^e[u TABLE1 쐬
function TForm1.DataTableMaking1 : Boolean ;
begin
   Result := False ;
   try
      IBTransaction1.Active := False ;
      IBTransaction1.StartTransaction ;
      IBQuery1.Close;
      IBQuery1.ParamCheck := False ;
      with IBQuery1.SQL do begin
         Clear ;
         Add('CREATE TABLE ' + TABLE1 + ' (' );
         Add('  N INTEGER NOT NULL UNIQUE,');
         Add('  PNAME VARCHAR(20),');
         Add('  PKANA VARCHAR(20),');
         Add('  ZIP1 VARCHAR(3),');
         Add('  ZIP2 VARCHAR(4),');
         Add('  ADR1 VARCHAR(80),');
         Add('  ADR2 VARCHAR(80),');
         Add('  TEL VARCHAR(14),');
         Add('  FAX VARCHAR(14),');
         Add('  PHONE VARCHAR(14),');
         Add('  BIKO VARCHAR(80)');
         Add('  );');
      end;
      if not(IBQuery1.Prepared) then IBQuery1.Prepare;
      IBQuery1.ExecSQL;
      IBTransaction1.Commit;
      Result := True ;
   except
      IBTransaction1.Rollback ;
   end;
   IBQuery1.Active := False ;
   IBTransaction1.Active := False ;
end;

// f[^e[u TABLE1 폜
function TForm1.DataTableDelete1 : Boolean ;
begin
   Result := False ;
   try
      IBTransaction1.Active := False ;
      IBTransaction1.StartTransaction ;
      IBQuery1.Close;
      IBQuery1.ParamCheck := False ;
      with IBQuery1.SQL do begin
         Clear ;
         Add('DROP TABLE ' + TABLE1 + ';' );
      end;
      if not(IBQuery1.Prepared) then IBQuery1.Prepare;
      IBQuery1.ExecSQL;
      IBTransaction1.Commit;
      Result := True ;
   except
      IBTransaction1.Rollback ;
   end;
   IBQuery1.Active := False ;
   IBTransaction1.Active := False ;
end;

// N
procedure TForm1.FormShow(Sender: TObject);
begin
   // vÔtH_擾܂
   AppPath := ExtractFilePath(Application.ExeName) ;
   // f[^t@ĆAvOt@C̊gqu.datvɂ
   DatFile := ChangeFileExt(Application.ExeName,'.dat') ;
   OpenDatFile(DatFile) ;
   if (DBfold = '')or(DBname = '') then exit;
   // NɃf[^x[X쐬܂
   IBDataBase1.DatabaseName := DBserv + DBfold + DBname ;
   IBDatabase1.Params.Clear ;
   IBDatabase1.Params.Add('USER "SYSDBA"');
   IBDatabase1.Params.Add('PASSWORD "masterkey"');
   IBDatabase1.Params.Add('PAGE_SIZE 4096');
   try
      IBDataBase1.CreateDatabase;
   except
      // ɍ쐬ς
   end;
   // f[^x[Xڑ
   DataBaseConnect ;
end;

// I
procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
   // f[^x[Xؒf
   DataBaseDisConnect ;
   //
   SaveDatFile(DatFile) ;
end;

// f[^x[Xݒ
procedure TForm1.Button1Click(Sender: TObject);
begin
   // ̉ʂ
   Form3.Close ;
   Form4.Close ;
   Form5.Close ;
   // f[^x[Xؒf
   DataBaseDisConnect ;

   Form2.ShowModal ;

   // f[^x[Xڑ
   DataBaseConnect ;
end;

// f[^
procedure TForm1.Button2Click(Sender: TObject);
begin
   Form3.Show ;
end;

// f[^ҏW
procedure TForm1.Button3Click(Sender: TObject);
begin
   Form4.Show ;
end;

// f[^ꗗ\
procedure TForm1.Button4Click(Sender: TObject);
begin
   Form5.Show ;
end;

// f[^CSVo
procedure TForm1.Button5Click(Sender: TObject);
var
   fn : string ;
   F : TextFile ;
   m : Boolean ;  // True:TXT  False:CSV
   s : string ;
   i : integer ;
begin
   if not(IBDatabase1.Connected) then exit ; // ڑ
   if not(Form1.DataTableCheck(TABLE1)) then exit ;   // e[u

   if (SaveDialog1.Execute) then begin
      fn := SaveDialog1.FileName ;
      if (AnsiUpperCase(ExtractFileExt(fn)) = '') then begin
         if (SaveDialog1.FilterIndex = 1) then
            fn := fn + '.txt'
         else
            fn := fn + '.csv';
      end;
      if (AnsiUpperCase(ExtractFileExt(fn)) = '.CSV') then
         m := False
      else
         m := True ;
      //
      try
         AssignFile(F, fn);
         ReWrite(F);
         // Psڂ͍ږ
         if (m) then begin
            s := 'o^ԍ' + #9 + 'O' + #9 + 'O()' + #9
               + 'X֔ԍ1' + #9 + 'X֔ԍ2' + #9
               + 'Z1' + #9 + 'Z2' + #9 + 'dbԍ' + #9
               + 'FAXԍ' + #9 + 'gєԍ' + #9 + 'l';
         end
         else begin
            s := '"o^ԍ","O","O()","X֔ԍ1",'
               + '"X֔ԍ2","Z1","Z2","dbԍ",'
               + '"FAXԍ","gєԍ","l"';
         end;
         WriteLn(F, s);
         // Qsڈȍ~
         IBQuery1.Active := False ;
         IBTransaction1.Active := False ;
         IBQuery1.ParamCheck := True ;
         with IBQuery1.SQL do begin
            Clear ;
            Add('SELECT * FROM '+TABLE1);
            Add('  ORDER BY N;');
         end;
         IBQuery1.Open ;
         IBQuery1.First ;
         while not(IBQuery1.Eof) do begin
            s := IBQuery1.Fields[0].AsString ;
            for i:=1 to 10 do begin
               if (m) then begin
                  s := s + #9 + IBQuery1.Fields[i].AsString ;
               end
               else begin
                  s := s + ',"' + IBQuery1.Fields[i].AsString + '"' ;
               end;
            end;
            WriteLn(F, s);
            IBQuery1.Next ;
         end;
         IBQuery1.Active := False ;

         CloseFile(F);
      except
         CloseFile(F);
         if FileExists(fn) then DeleteFile(fn);
      end;
   end;
end;

// f[^CSVǂݍ
procedure TForm1.Button6Click(Sender: TObject);
var
   fn : string ;
   F : TextFile ;
   s : string ;
   t : array[0..10] of string ;
   u : TStringList;
   i,j : integer ;
begin
   if not(IBDatabase1.Connected) then exit ; // ڑ
   // ̉ʂ
   Form3.Close ;
   Form4.Close ;
   Form5.Close ;
   //
   if (OpenDialog1.Execute) then begin
      fn := OpenDialog1.FileName ;
      if (AnsiUpperCase(ExtractFileExt(fn)) <> '.TXT')
      and(AnsiUpperCase(ExtractFileExt(fn)) <> '.CSV') then
         exit ;   // Sʂ̃t@CȂ̂Œf
      //
      if (Form1.DataTableCheck(TABLE1)) then begin
         // e[uꍇ͍폜
         if not(DataTableDelete1) then exit ;   // Ȃꍇ͒f
      end;
      // e[uVK쐬
      if not(DataTableMaking1) then exit ;   // 쐬oȂꍇ͒f
      //
      try
         AssignFile(F, fn);
         FileMode := 0;
         Reset(F);
         // 1sڂ͓ǂݔ΂
         ReadLn(F, s);
         // Qsڈȍ~
         u := TStringList.Create ;
         while not(Eof(F)) do begin
            ReadLn(F, s);
            for i:=0 to 10 do
               t[i] := '' ;
            // ڐ؂o
            u.CommaText := s ;
            j := u.Count ;
            if (j > 11) then j := 11 ;
            for i:=0 to j-1 do
               t[i] := u[i] ;
            // eڂo^oԂɂ
            if (t[0] = '') then t[0] := '0';
            for i:=1 to 10 do begin
               if (t[i] = '') then
                  t[i] := 'NULL'
               else
                  t[i] := '''' + t[i] + '''' ;
            end;
            // ǉo^
            try
               IBTransaction1.Active := False ;
               IBTransaction1.StartTransaction ;
               IBQuery1.Close;
               IBQuery1.ParamCheck := False ;
               with IBQuery1.SQL do begin
                  Clear ;
                  Add('INSERT INTO ' + TABLE1 + ' (');
                  Add('  N, PNAME, PKANA, ZIP1, ZIP2,');
                  Add('  ADR1, ADR2, TEL, FAX, PHONE, BIKO)');
                  Add('VALUES (');
                  for i:=0 to 10 do begin
                     if (i < 10) then
                        s := '  ' + t[i] + ','
                     else
                        s := '  ' + t[i] + ');' ;
                     Add(s);
                  end;
               end;
               if not (IBQuery1.Prepared) then IBQuery1.Prepare;
               IBQuery1.ExecSQL;
               IBTransaction1.Commit;
            except
               IBTransaction1.Rollback ;
            end;
            IBQuery1.Active := False ;
            IBTransaction1.Active := False ;
         end;
         u.Free ;

         CloseFile(F);
      except
         CloseFile(F);
      end;
   end;
end;

// I
procedure TForm1.Button0Click(Sender: TObject);
begin
   close ;
end;

end.
